#include "global.h"
#include <Xm/SeparatoG.h>

Widget sep1,sep2,sep3,sep4;

Widget g_make_option(option_name,mnem_char,id,sensitive,CB,mp,meta_label,meta_char)
char *option_name;
char mnem_char;
int id;
Boolean sensitive;
XtCallbackProc CB;
Widget mp;
char *meta_label;
char *meta_char;
{
	int ac;
	Arg al[10];
	Widget b;

	ac = 0;
	XtSetArg(al[ac], XmNlabelString,
		 XmStringCreateLtoR(option_name, XmSTRING_DEFAULT_CHARSET)); ac++;
	XtSetArg(al[ac], XmNmnemonic, mnem_char); ac++;
	XtSetArg(al[ac], XmNaccelerator, meta_char); ac++;
        XtSetArg(al[ac], XmNacceleratorText,XmStringCreateLtoR(meta_label,XmSTRING_DEFAULT_CHARSET)); ac++;
	b = XmCreatePushButtonGadget (mp, option_name, al, ac);
	XtAddCallback (b, XmNactivateCallback, CB, id);
	XtManageChild (b);
	if (!sensitive) XtSetSensitive(b, sensitive);
	return(b);
}

/**************************************************************
CreateMwsrcMenuBar creates the menu bar
**************************************************************/
Widget CreateMwsrcMenuBar (parent)
Widget		parent;
{
	Widget		menu_bar;	/*  RowColumn	 		*/
	Widget		cascade;	/*  CascadeButton		*/
	Widget		menu_pane;	/*  RowColumn	 		*/
	Widget		button;		/*  PushButton			*/
	Arg		al[10];		/*  arg list			*/
	register int	ac;		/*  arg count			*/

/* Create Menus area.  */
	ac = 0;
	menu_bar = XmCreateMenuBar (parent, "menu_bar", al, ac);


/* Create "File" Menu.  */
	ac = 0;
	menu_pane = XmCreatePulldownMenu (menu_bar, "menu_pane", al, ac);

      open_button= g_make_option("Open...",'O',MENU_OPEN,True,MwsrcMenuCB,menu_pane,"Meta+O","Meta<Key>o:");

      new_button=g_make_option("New...",'N',MENU_NEW,True,MwsrcMenuCB,menu_pane,"Meta+N","Meta<Key>n:");

      save_button=g_make_option("Save",'S',MENU_SAVE,False,MwsrcMenuCB,menu_pane,"Meta+W","Meta<Key>w:");

      save_as_button=g_make_option("Save As...",'A',MENU_SAVE_AS,False,MwsrcMenuCB,menu_pane,"","");

      close_button=g_make_option("Close",'A',MENU_CLOSE,False,MwsrcMenuCB,menu_pane,"Meta+C","Meta<Key>c:");



	/* exit button */
	ac = 0;
	XtSetArg(al[ac], XmNlabelString,
		 XmStringCreateLtoR("Exit", XmSTRING_DEFAULT_CHARSET)); ac++;
	XtSetArg(al[ac], XmNacceleratorText,
		 XmStringCreateLtoR("Meta+Q", XmSTRING_DEFAULT_CHARSET)); ac++;
	XtSetArg(al[ac], XmNaccelerator, "Meta<Key>q:"); ac++;
	button = XmCreatePushButtonGadget (menu_pane, "Exit", al, ac);
	XtAddCallback (button, XmNactivateCallback, MwsrcMenuCB, MENU_EXIT);
	XtManageChild (button);

	/* make the menu */
	ac = 0;
	XtSetArg (al[ac], XmNsubMenuId, menu_pane);  ac++;
	XtSetArg(al[ac], XmNlabelString,
		 XmStringCreateLtoR("File", XmSTRING_DEFAULT_CHARSET)); ac++;
        XtSetArg(al[ac], XmNmnemonic, 'F'); ac++;
	cascade = XmCreateCascadeButton (menu_bar, "File", al, ac);
	XtManageChild (cascade);

/* Create "Edit" Menu.  */
	ac = 0;
	menu_pane = XmCreatePulldownMenu (menu_bar, "menu_pane", al, ac);

      cut_button=g_make_option("Cut",'t',MENU_CUT,False,MwsrcMenuCB,menu_pane,
			"Shift+Remove","");

      copy_button=g_make_option("Copy",'C',MENU_COPY,False,MwsrcMenuCB,menu_pane,
			"Ctrl+Insert Here","");

      paste_button=g_make_option("Paste",'P',MENU_PASTE,False,MwsrcMenuCB,menu_pane,
			"Shift+Insert Here","");

      clear_button=g_make_option("Clear",'e',MENU_CLEAR,False,MwsrcMenuCB,menu_pane,
			"<X]","");

	ac = 0;
	XtSetArg (al[ac], XmNsubMenuId, menu_pane);  ac++;
	XtSetArg(al[ac], XmNlabelString,
		 XmStringCreateLtoR("Edit", XmSTRING_DEFAULT_CHARSET)); ac++;
        XtSetArg(al[ac], XmNmnemonic, 'E'); ac++;
	cascade= XmCreateCascadeButton (menu_bar, "Edit", al, ac);
	XtManageChild (cascade);



        ac=0;
        XtSetArg(al[ac], XmNmnemonic, 'H'); ac++;
        cascade=XmCreateCascadeButton(menu_bar, "Help", al, ac);
	XtAddCallback (cascade, XmNactivateCallback, MwsrcMenuCB, MENU_ABOUT);
	XtManageChild (cascade);

        ac=0;
        XtSetArg (al[ac],XmNmenuHelpWidget,cascade); ac++;
        XtSetValues(menu_bar,al,ac);


/* Wrap up */

	return (menu_bar);
}
